#!/usr/bin/env python3
#-*- coding: utf-8 -*-

import re, sys, os
from glob import glob

def rec_list_dir(path_to_dir):
    result = [y for x in os.walk(path_to_dir) for y in glob(os.path.join(x[0], '*.md'))]
    return result

def read_file(path_to_file): # Reads the file
    with open(path_to_file) as f:
        try:
            content = f.read()
            f.close()
            return content
        except:
            return ""

def append_file(path_to_file, content): # Appends to the file
    with open(path_to_file, "a") as f:
        f.write(content)
        f.close()

vault_dir = sys.argv[1]

titles = ""

for file in rec_list_dir(vault_dir):
    content = read_file(file)
    title = re.search(r'^# (.*?)\n', content)
    if title != None:
        titles += ("- " + title.group(1) + "\n")

append_file(os.path.join(vault_dir, "List of All Note Titles.md"), titles)
